<?php
use Doctrine\DBAL\Types\Type;

require __DIR__ . "/vendor/autoload.php";
require __DIR__ . "/vendor/zeedhi/framework/bootstrap.php";
require __DIR__ . "/vendor/teknisa/libraries-next/scripts/bootstrap.php";
require __DIR__ . "/vendor/teknisa/pebLibraries/bootstrap.php";

$instanceManager = \Zeedhi\Framework\DependencyInjection\InstanceManager::getInstance();

$routes = array();
$routes[] = __DIR__ . '/vendor/teknisa/libraries-next/libRoutes.json';
$routes[] = __DIR__ . '/config/routes.json';
$routes[] = __DIR__.'/vendor/teknisa/pebLibraries/config/pebLib.json';

$instanceManager->loadFromFile(__DIR__ . '/config/db.xml');
$instanceManager->loadFromFile(__DIR__ . '/config/controllers.xml');
$instanceManager->loadFromFile(__DIR__ . '/config/general.xml');
$instanceManager->loadFromFile(__DIR__ . '/config/parameters.xml');
$instanceManager->loadFromFile(__DIR__ . "/config/fileServer.xml");
$instanceManager->loadFromFile(__DIR__ . '/config/environment.xml');
$instanceManager->loadFromFile(__DIR__ . '/config/services.xml');
$instanceManager->loadFromFile(__DIR__ . '/config/util.xml');

$container = $instanceManager->getContainer();

$instanceManager->registerService('routeParser', new \Zeedhi\Framework\Routing\Parsers\JSONFormat($routes));

$instanceManager->compile();

//Necessário para uso das entidades do projetotecfood
Type::overrideType(Type::DATE, 'Setforms2\Shared\ORM\DateType');
Type::overrideType(Type::DATETIME, 'Setforms2\Shared\ORM\DateTimeType');
$entity_manager = $instanceManager->getService('entityManager');
\Setforms2\Shared\Registry::store("EntityManager", $entity_manager);
\Setforms2\Shared\Registry::store("EntityManagerConnection", $entity_manager->getConnection());