<?php


/**
 * ProdutoLogic
 *
 * @package Logic
 *
 * @author  erikasouza
 *
 */
class ProdutoLogic
{

    private $_cdprodesto;
    private $_vrfatoconv;
    const RESULTADO_SEM_REGISTRO = 10;

    public function __construct($nrorg, $cdproduto) {
        $produto = ProdutoEntity::retornaProduto($nrorg, $cdproduto);
        $this->_cdprodesto = $produto->getCdprodesto();
        $this->_vrfatoconv = $produto->getVrfatoconv();
    }


    public function getProdutoEstoque() {
        return $this->_cdprodesto;
    }


    public function getFatorConversao() {
        return $this->_vrfatoconv;
    }


    /**
     * Retorna o registro de um determinado produto.
     *
     * @param integer $nrorg     N?mero da Organiza??o.
     * @param integer $cdarvprod C?digo da arvore de Produto.
     *
     * @return ProdutoEntity|boolean
     */
    public static function retornaArvoreProduto($nrorg, $cdarvprod){
        try {
            $retorno = ProdutoEntity::retornaArvoreProduto($nrorg, $cdarvprod);
            return $retorno;
        }catch (Exception $e) {
            switch ($e->getCode())
            {
                case ProdutoEntity::RESULTADO_SEM_REGISTRO:
                    return ProdutoEntity::RESULTADO_SEM_REGISTRO;
                default:
                    tk_warning('Erro desconhecido: '.$e->getMessage());
                    return false;
            }
        }

    }


    public static function retornaFilhosProduto($nrorg, $cdarvprod){
        try {
            $retorno = ProdutoEntity::retornaFilhosProduto($nrorg, $cdarvprod);
            return $retorno;
        }catch (Exception $e) {
            switch ($e->getCode())
            {
                case ProdutoEntity::RESULTADO_SEM_REGISTRO:
                    return ProdutoEntity::RESULTADO_SEM_REGISTRO;
                default:
                    tk_warning('Erro desconhecido: '.$e->getMessage());
                    return false;
            }
        }

    }

}