import {
  Metadata,
  Http,
  Loader,
  I18n,
} from '@zeedhi/core';
import {
  Select,
  Text,
  DateRange,
  IButtonEvent,
  IterableComponentRender,
  Form,
  DialogService,
} from '@zeedhi/common';
import {} from '@zeedhi/teknisa-components-common';

export class ServiceController {
    private Utilities = Loader.getInstance('Utilities');

    public serviceTitleVisibility: boolean = false;

    public isExpanded: boolean = true;

    public mainPageVisibility: boolean = true;

    public userAuthCalc: boolean = false;

    public CalcRequestVisibility: boolean = false;

    public servicePaginationVisibility: boolean = false;

    public cardDetailsVisibility: boolean = false;

    public productsDetails: boolean = false;

    public productsPaginationVisibility: boolean = false;

    public productsTitleVisibility: boolean = false;

    public addProductButtonVisibility: boolean = false;

    public paramsDeleteProduct: any;

    public IDBLOQALTPRA: any;

    public HRINICATEN: any;

    public DTPREVRETI: any;

    public componentToBeDeleted: any;

    public deleteSuccessfully: string = 'Item excluído com sucesso.';

    public CalcSuccessfully: string = 'Calculo feito com sucesso.';

    public deleteText: string = 'Deseja excluir o item selecionado?';

    public deleteTitle: string = 'Excluir item?';

    public calcText: string = 'Este processo apagará os produtos inseridos manualmente! Deseja recalcular a requisição?';

    public calcTitle: string = 'Calcular Requisição?';

    public mainCollapseCardName = '<h2>Requisição por Serviço</h2>';

    public mainCollapseCardDescription = '';

    public serviceSelectedData: any = {
    };

    public arrayProduct: any = {
    };

    public arrayPlates: any = {
    };

    public messageData: any;

    public productSelectedData: any = {
    };

    public formSelectedData: any = {
    };

    public closeConfirmationDialog: any = {
      click: () => DialogService.hide(),
    };

  public filterServicesByUnit() {
    const unitSelectValue = Metadata.getInstance<Select>('unitsForWithdrawal').value;
    const servicesSelect = Metadata.getInstance<Select>('unitServices');

    if (unitSelectValue !== null) {
      const conditions = {
        CDFILIAL: unitSelectValue.CDFILIAL,
        CDOPERADOR: localStorage.getItem('CDOPERADOR'),
      };
      servicesSelect.datasource.filter = conditions;
      servicesSelect.datasource.get();
    } else {
      servicesSelect.datasource.clearFilter();
    }

    if (unitSelectValue !== null) {
      this.loadWithdrawalDates();
    }
  }

  public loadWithdrawalDates() {
    const unitSelectValue = Metadata.getInstance<Select>('unitsForWithdrawal').value;
    const menuDate = Metadata.getInstance<DateRange>('dateRange');
    const conditions = {
      CDFILIAL: unitSelectValue,
    };

    Http.post('/planningWithdrawalData', conditions).then((response) => {
      const params = response.data.dataset.planningWithdrawalData;
      menuDate.value = params[0].DTPROCESSA?.split(' ')[0];
    });
  }

  public loadServiceBillData() {
    this.userAuthCalc = false;
    const form = Metadata.getInstance<Form>('planningWithdrawalForm');
    const validation = form.validate();
    if (validation) {
      const unitSelect = Metadata.getInstance<Select>('unitsForWithdrawal');
      const serviceSelected = Metadata.getInstance<Select>('unitServices');
      const productsSelected = Metadata.getInstance<Select>('unitProducts');
      const dateMenu = Metadata.getInstance<DateRange>('dateRange');
      const serviceIterableCard = Metadata.getInstance<IterableComponentRender>('iterableWaybillCard');
      const products = Metadata.getInstance<IterableComponentRender>('iterableProducts');
      this.HRINICATEN = serviceSelected.datasource.data.find((item) => item.CDSERVFILI === serviceSelected.value)?.HRINICATEN;
      this.DTPREVRETI = dateMenu.value;
      this.clearVisibility();
      products.datasource.clearFilter();
      serviceIterableCard.datasource.clearFilter();
      const conditions = {
        NRORG: localStorage.getItem('NRORG'),
        CDFILIAL: unitSelect.value.CDFILIAL,
        CDSERVFILI: serviceSelected.value,
        DTPREVRETI: dateMenu.value,
        IDPREVRETI: productsSelected.value,
      };
      Http.post('/prevreti', conditions).then((callbackPrevreti) => {
        Http.post('/servico', conditions).then((callback) => {
          [this.serviceSelectedData] = callback.data.dataset.params;
          let IDUTRETIPRAT = '';
          if (callback && callback.data && callback.data.dataset.params && callback.data.dataset.params.length > 0) {
            this.IDBLOQALTPRA = callback.data.dataset.params[0].IDBLOQALTPRA;
            IDUTRETIPRAT = callback.data.dataset.params[0].IDUTRETIPRAT;
          }
          this.formSelectedData = {
            IDPREVRETI: productsSelected.value,
            DTPREVRETI: dateMenu.value,
            IDUTRETIPRAT,
          };
          if (callbackPrevreti.data.dataset.params.length === 0) {
            this.calculaRequisicaoServico(conditions).then(() => {
              if (IDUTRETIPRAT === 'S') {
                this.servicePaginationVisibility = true;
                serviceIterableCard.datasource.filter = conditions;
                serviceIterableCard.datasource.get().then((response) => {
                  if (response.length > 0 && response[0]?.CDOPERADOR) {
                    this.verifyAuthCDOPERADOR(response[0].CDOPERADOR);
                  } else {
                    this.verifyAuthCDOPERADOR(null);
                  }
                  this.loadMessage(conditions);
                  this.arrayPlates = response;
                  this.addProductButtonVisibility = (this.IDBLOQALTPRA === 'N');
                  this.mainCollapseCardName = `${unitSelect.value.CDFILIAL} - ${unitSelect.value.NMFILIAL}`;
                  this.mainCollapseCardDescription = `${serviceSelected.value} - ${callback.data.dataset.params[0].NMSERVICO}`;
                  this.CalcRequestVisibility = true;
                });
              } else {
                const paramsQuery = {
                    ...conditions,
                    CDTIPOPRAT: 'T',
                    NRREQUEXTR: 'T',
                    CDPRATO: null,
                };
                products.datasource.filter = paramsQuery;
                products.datasource.get().then((response) => {
                  if (response.length > 0 && response[0]?.CDOPERADOR) {
                    this.verifyAuthCDOPERADOR(response[0].CDOPERADOR);
                  } else {
                    this.verifyAuthCDOPERADOR(null);
                  }
                  this.loadMessage(conditions);
                  this.productsTitleVisibility = true;
                  this.productsPaginationVisibility = true;
                  this.arrayProduct = response;
                  this.mainCollapseCardName = `${unitSelect.value.CDFILIAL} - ${unitSelect.value.NMFILIAL}`;
                  this.mainCollapseCardDescription = `${serviceSelected.value} - ${callback.data.dataset.params[0].NMSERVICO}`;
                  this.CalcRequestVisibility = true;
                });
              }
            });
          } else if (IDUTRETIPRAT === 'S') {
              this.servicePaginationVisibility = true;
              serviceIterableCard.datasource.filter = conditions;
              serviceIterableCard.datasource.get().then((response) => {
                if (response.length > 0 && response[0]?.CDOPERADOR) {
                  this.verifyAuthCDOPERADOR(response[0].CDOPERADOR);
                } else {
                  this.verifyAuthCDOPERADOR(null);
                }
                this.loadMessage(conditions);
                this.arrayPlates = response;
                this.addProductButtonVisibility = (this.IDBLOQALTPRA === 'N');
                this.mainCollapseCardName = `${unitSelect.value.CDFILIAL} - ${unitSelect.value.NMFILIAL}`;
                this.mainCollapseCardDescription = `${serviceSelected.value} - ${callback.data.dataset.params[0].NMSERVICO}`;
                this.CalcRequestVisibility = true;
              });
            } else {
              const paramsQuery = {
                  ...conditions,
                  CDTIPOPRAT: 'T',
                  NRREQUEXTR: 'T',
                  CDPRATO: null,
              };
              products.datasource.filter = paramsQuery;
              products.datasource.get().then((response) => {
                if (response.length > 0 && response[0]?.CDOPERADOR) {
                  this.verifyAuthCDOPERADOR(response[0].CDOPERADOR);
                } else {
                  this.verifyAuthCDOPERADOR(null);
                }
                this.loadMessage(conditions);
                this.arrayProduct = response;
                this.productsTitleVisibility = true;
                this.productsPaginationVisibility = true;
                this.cardDetailsVisibility = true;
                this.mainCollapseCardName = `${unitSelect.value.CDFILIAL} - ${unitSelect.value.NMFILIAL}`;
                this.mainCollapseCardDescription = `${serviceSelected.value} - ${callback.data.dataset.params[0].NMSERVICO}`;
                this.CalcRequestVisibility = true;
              });
            }
        });
      });
    }
  }

  public async clickCard({ component }: any) {
    this.mainPageVisibility = false;
    this.addProductButtonVisibility = false;
    this.productsPaginationVisibility = true;
    this.CalcRequestVisibility = false;
    this.cardDetailsVisibility = !this.mainPageVisibility;
    const products = await Metadata.getInstance<IterableComponentRender>('iterableProducts');
    const params = component.name.split('_');
    const unitSelect = Metadata.getInstance<Select>('unitsForWithdrawal');
    const serviceSelected = Metadata.getInstance<Select>('unitServices');
    const dateMenu = Metadata.getInstance<DateRange>('dateRange');
    const productsSelected = Metadata.getInstance<Select>('unitProducts');
    const conditions = {
      NRORG: localStorage.getItem('NRORG'),
      CDFILIAL: unitSelect.value.CDFILIAL,
      CDSERVFILI: serviceSelected.value,
      DTPREVRETI: dateMenu.value,
      IDPREVRETI: productsSelected.value,
      CDTIPOPRAT: params[0],
      CDPRATO: params[1],
      NRREQUEXTR: params[2],
    };
    this.productSelectedData = {
      CDTIPOPRAT: params[0],
      CDPRATO: params[1],
      NRREQUEXTR: params[2],
      CDFILAUXPRAT: params[3],
    };
    const titleDetail = Metadata.getInstance<Text>('titleProductsDetails');
    const titleDetailNMPLATE = Metadata.getInstance<Text>('nmplate');
    const titleDetailCDPRATO = Metadata.getInstance<Text>('id_prato');
    const Mask = (localStorage.getItem('CDPICTPRAT') && localStorage.getItem('CDPICTPRAT') !== '')
      ? localStorage.getItem('CDPICTPRAT')?.replace(/[0-9a-zA-Z!@#$%^&*()_+]/g, 'N') : 'NN.NN.NN.NNN';
    const plateMask = this.Utilities.applyMask(Mask, this.productSelectedData.CDPRATO);
    titleDetail.text = component.children[0].name;
    titleDetailNMPLATE.text = component.children[1].name;
    titleDetailCDPRATO.text = plateMask;
    this.productsTitleVisibility = true;
    this.productsDetails = true;
    products.datasource.filter = conditions;
    products.datasource.get().then((response) => {
      this.arrayProduct = response;
      this.verifyAuthCDOPERADOR(response[0].CDOPERADOR);
    });
  }

  public returnToMainPage() {
    const products = Metadata.getInstance<IterableComponentRender>('iterableProducts');
    const withdrawalsCards = Metadata.getInstance<IterableComponentRender>('iterableWaybillCard');
    products.datasource.clearFilter();
    withdrawalsCards.reload();
    this.CalcRequestVisibility = true;
    this.arrayProduct = null;
    this.addProductButtonVisibility = (this.IDBLOQALTPRA === 'N');
    this.servicePaginationVisibility = true;
    this.productsTitleVisibility = false;
    this.cardDetailsVisibility = false;
    this.productsDetails = false;
    this.productsPaginationVisibility = false;
    this.productSelectedData = {
      CDTIPOPRAT: null,
      CDPRATO: null,
      NRREQUEXTR: null,
      CDFILAUXPRAT: null,
    };
    this.mainPageVisibility = !this.cardDetailsVisibility;
  }

  public calculaRequisicaoServico(conditions: any) {
    const params = {
      NRORG: localStorage.getItem('NRORG'),
      CDOPERADOR: localStorage.getItem('CDOPERADOR'),
      DTHRCALCPR: this.getCurrentDateFormatted(),
      PEACRESCIMO: 0,
      IDARREDOND: 'N',
      IDPRODUTOS: this.validaIdProdutos(conditions.IDPREVRETI),
      STDTINICIAL: null,
      STDTFINAL: null,
      conditions,
    };
    return Http.post('/calculaRequisicaoServico', params);
  }

  public loadMessage(conditions: any) {
    Http.post('/message', conditions).then((response) => {
      this.messageData = response.data.dataset.params[0] ? response.data.dataset.params[0] : conditions;
    });
  }

  private validaIdProdutos(IDPREVRETI: string): string | undefined {
      let idprodutos: string | undefined;
      if (IDPREVRETI === 'C') {
          idprodutos = 'CXX';
      } else if (IDPREVRETI === 'F') {
          idprodutos = 'XFX';
      } else if (IDPREVRETI === 'P') {
          idprodutos = 'XXP';
      }
      return idprodutos;
  }

  public getCurrentDateFormatted(): string {
    const date = new Date();
    const day = String(date.getDate()).padStart(2, '0');
    const month = String(date.getMonth() + 1).padStart(2, '0'); // Mês começa em 0
    const year = date.getFullYear();

    return `${day}/${month}/${year}`;
  }

  public deleteProductDialog({ component, event }: IButtonEvent) {
    if (event) {
      event.stopPropagation();
    }
    const itens = component.name.split('_');
    if (component && component.parent && component.parent.parent) {
      this.componentToBeDeleted = component.parent.parent;
    }
    const sendObject = [{
      NRORG: localStorage.getItem('NRORG'),
      CDFILIAL: itens[1],
      CDSERVFILI: itens[2],
      IDPREVRETI: itens[3],
      DTPREVRETI: itens[4].split(' ')[0],
      CDPRODUTO: itens[5],
      CDTIPOPRAT: itens[6],
      CDFILAUXPRAT: itens[7],
      CDPRATO: itens[8],
    }];
    this.paramsDeleteProduct = sendObject;
    this.verifyAuthCDOPERADOR(itens[9]);
    const dialogParams = {
      deleteTitle: I18n.translate(this.deleteTitle),
      deleteText: I18n.translate(this.deleteText),
    };
    this.Utilities.showConfirmationDialog(dialogParams.deleteTitle, dialogParams.deleteText, this.closeConfirmationDialog, this.deleteProductButton);
  }

  public deleteProductButton: any = {
    click: () => this.deleteProduct(),
  };

  public deleteProduct() {
    const sendObject = this.paramsDeleteProduct;
    Http.post('/validGrupOper').then((callbackValidGrupOper) => {
      if (!callbackValidGrupOper.data.dataset.denied && this.userAuthCalc) {
        Http.post('/removeProduto', sendObject).then(() => {
          DialogService.hide();
          if (Array.isArray(this.arrayProduct) && sendObject[0].CDPRODUTO !== 'null') {
            this.arrayProduct = this.arrayProduct.filter((produto: any) => produto.CDPRODUTO !== sendObject[0].CDPRODUTO);
          }
          if (Array.isArray(this.arrayPlates) && sendObject[0].CDTIPOPRAT !== 'null' && sendObject[0].CDPRATO !== 'null') {
            this.arrayPlates = this.arrayPlates.filter(
              (plate: any) => !(plate.CDTIPOPRAT === sendObject[0].CDTIPOPRAT && plate.CDPRATO === sendObject[0].CDPRATO),
            );
          }
          this.componentToBeDeleted.isVisible = false;
          const deleteSuccessfully = I18n.translate(this.deleteSuccessfully);
          this.Utilities.successMessage(deleteSuccessfully);
        });
      } else {
        DialogService.hide();
        this.Utilities.failMessage(I18n.translate('Operador Não Autorizado'));
      }
    });
  }

  public setWithdrawalDate({ component }: any) {
    const withdrawalDate = Metadata.getInstance<DateRange>('dateRange');
    withdrawalDate.value = component.value;
  }

  public clearVisibility() {
    this.serviceTitleVisibility = true;
    this.addProductButtonVisibility = false;
    this.isExpanded = false;
    this.servicePaginationVisibility = false;
    this.cardDetailsVisibility = false;
    this.productsTitleVisibility = false;
    this.productsPaginationVisibility = false;
    this.CalcRequestVisibility = false;
  }

  public verifyAuthCDOPERADOR(cdoper: any) {
    if (!cdoper || cdoper === undefined || cdoper === localStorage.getItem('CDOPERADOR')) {
      this.userAuthCalc = true;
    }
  }

  public calcProductDialog({ event }: IButtonEvent) {
    if (event) {
      event.stopPropagation();
    }
    const dialogParams = {
      calcTitle: I18n.translate(this.calcTitle),
      calcText: I18n.translate(this.calcText),
    };
    this.Utilities.showConfirmationDialog(dialogParams.calcTitle, dialogParams.calcText, this.closeConfirmationDialog, this.CalcProductButton);
  }

  public CalcProductButton: any = {
    click: () => this.CalcProduct(),
  };

  public CalcProduct() {
    const unitSelect = Metadata.getInstance<Select>('unitsForWithdrawal');
    const serviceSelected = Metadata.getInstance<Select>('unitServices');
    const productsSelected = Metadata.getInstance<Select>('unitProducts');
    const dateMenu = Metadata.getInstance<DateRange>('dateRange');
    const conditions = {
      NRORG: localStorage.getItem('NRORG'),
      CDFILIAL: unitSelect.value.CDFILIAL,
      CDSERVFILI: serviceSelected.value,
      DTPREVRETI: dateMenu.value,
      IDPREVRETI: productsSelected.value,
    };
    this.calculaRequisicaoServico(conditions).then(() => {
      DialogService.hide();
      this.loadServiceBillData();
      const CalcSuccessfully = I18n.translate(this.CalcSuccessfully);
      this.Utilities.successMessage(CalcSuccessfully);
    });
  }
}
